<template>
    <div class="payment">
        <div class="payment-data">
            <ui-row>
                <ui-col :xs="24" :md="12">
                    <div class="payment-data__sum">
                        <ui-input label="Сумма платежа" v-model.number="amount" :error="$v.amount.$invalid ? 'Минимальная сумма оплаты 10 ₽' : ''">
                            <template slot="suffix"
                                      class="currency">
                                <span class="currency">₽</span>
                            </template>
                        </ui-input>
                    </div>
                </ui-col>

                <!-- платежи, у которых доступна сортировка -->
                <ui-col :xs="24" :md="12" v-if="isSortable">
                    <div class="payment-data__sort">
                        <ui-button link :block="$interface.isMobile" center @click.native="sortPayment">
                          <ui-row>
                              <ui-col flex center>
                                  <ui-icon :fill="$ui.colors.info" view-box="0 0 40 40">sort-20</ui-icon>
                                  Порядок оплаты
                              </ui-col>
                          </ui-row>
                        </ui-button>
                    </div>
                </ui-col>


                <!-- для посов -->
                <ui-col :xs="24" :md="12" v-else-if="$pay.paymentType === 'POS'" class="payment-data__pos">
                    <div class="">
                        <span class="title">
                            Осталось погасить по графику
                        </span>
                        <ui-row class="position" v-if="$POS.debt">
                            <ui-col :xs="12" :xl="12" :sm="12" class="position-title">
                                Долг за прошлый период
                            </ui-col>
                            <ui-col :xs="12" :xl="12" :sm="12" class="position-value">
                                <div class="overdue">
                                    {{$POS.debt|currency}} ₽
                                </div>

                            </ui-col>
                        </ui-row>
                        <ui-row class="position">
                            <ui-col :xs="12" :xl="12" :sm="12" class="position-title">
                                Сумма задолженности по графику
                            </ui-col>
                            <ui-col :xs="12" :xl="12" :sm="12" class="position-value">
                                <div class="current">
                                    {{$POS.currentPaySum|currency}} ₽
                                </div>

                            </ui-col>
                        </ui-row>
                    </div>
                </ui-col>
            </ui-row>

            <ui-row>
                <!--<pos-actions v-if="$pay.paymentType === 'POS'"></pos-actions>-->
                <ui-col :xs="24" :md="12" v-if="displayAdditionalService">
                    <div class="payment-data__services">
                        <additional-services></additional-services>
                    </div>
                </ui-col>

                <ui-col :xs="24" :md="12" >
                    <div class="payment-data__actions">
                        <ui-button color="red" block  bold @click.native="payHandler">
                            <ui-row block  align-items="center">
                                <ui-col :xs="12" :xl="12" :sm="12">{{textAmount}}</ui-col>
                                <ui-col :xs="12" :xl="12" :sm="12"
                                        flex align-items="center" text-right
                                >
                                    Оплатить <ui-icon :rotate="-90" fill="#fff">collapse-20</ui-icon>
                                </ui-col>
                            </ui-row>
                        </ui-button>
                    </div>
                </ui-col>
            </ui-row>
        </div>

        <modal-sort-payment></modal-sort-payment>
    </div>
</template>

<script>
    import AdditionalServices from '../components/AdditionalServices.vue';
    import ModalSortPayment from '@/components/Modals/SortPayment';
    import {required, minValue} from 'vuelidate/lib/validators';
    import {mapGetters} from 'vuex';
    import PosActions from '../actions/pos/index.vue';
    export default {
        name: 'component-payment-data',
        components: {
            AdditionalServices,
            ModalSortPayment,
            PosActions
        },
        computed: {
            amount: {
                get () {
                    return this.$pay.paymentAmount;
                },
                set (amount) {
                    this.$store.commit('PAYMENT_SET_AMOUNT', amount);
                }
            },

            displayAdditionalService () {
                return ['PDL', 'PDL_SUPPLEMENTARY', 'POS'].includes(this.$pay.paymentType) && this.$pay.selectedPaymentMethod === 'card'
            },

            isSortable () {
                return ['PDL', 'INSTALLMENT'].includes(this.$pay.paymentType);
            },

            textAmount () {
                return this.currencyFilter(this.amount + this.additionalServicesPrice) + ' ₽'
            },

            additionalServicesPrice () {
                return this.selectedAdditionalServices.reduce((a, service) => {
                    return a + service.price;
                }, 0);
            },

            selectedAdditionalServices () {
                return this.$pay.additionalServices.filter((/*iAdditionalService*/service) => {
                    return [3].includes(service.location_int) && service.selected;
                })
            },
            ...mapGetters(['$POS'])
        },

        validations: {
            amount: {
                required,
                minValue: minValue(10)
            }
        },

        created () {
            this.$store.commit('PAYMENT_SET_TYPE', 'POS');
            this.AJAX_LOADING({
                isShow: true,
                caption: 'Загрузка данных для оплаты',
                waitingTitle: '...'
            });
            this.$store.dispatch('PAYMENT_GET_ADDITIONAL_SERVICES').finally(() => {
                this.AJAX_LOADING(false);
            });

            switch(this.$pay.paymentType) {
                case 'PDL_SUPPLEMENTARY':
                    ['installment', 'prolongation', 'amnesty'].forEach((key) => {
                        if(this.$pdl.supplementary[key]?.depositAmount) {
                            this.amount = this.$pdl.supplementary[key].depositAmount;
                        }
                    });
                    break;
                case 'POS':
                    console.log(this.$POS);
                    this.amount = this.$POS.debt + this.$POS.currentPaySum;
                    break;
                case 'PDL':
                default:
                    this.amount = this.$pdl.sumTotal;
                    break;

            }
        },

        methods: {
            sortPayment () {
                this.$modal.show('modal-sort-payment');
            },

            payHandler () {
                this.$emit('payButtonPress');
            }
        }
    };
</script>

<style scoped>

</style>
